<template>
  <v-container class="big-container">
    <v-card class="mt-1">
      <v-card-text>
        <h3 class="mx-4">
          <v-icon color="primary"> mdi-laptop </v-icon>
          <span class="ml-4 primary--text" style="vertical-align: bottom"
            >Desenvolvedores</span
          >
        </h3>
      </v-card-text>
    </v-card>

    <v-card class="mt-4 pb-4">
      <v-row wrap class="mx-6" dense>
        <v-col cols="12" sm="1" class="mt-8 pl-2">
          <v-btn solo block height="49" class="white" @click="createDeveloper">
            <v-icon color="primary"> mdi-plus </v-icon>
          </v-btn>
        </v-col>
        <v-col cols="12" sm="11" md="9" class="mt-8">
          <v-text-field
            v-model="findName"
            placeholder="Pesquisar nome"
            solo
            prepend-inner-icon="mdi-magnify"
            @keypress.enter="findNameStore"
          />
        </v-col>
        <v-col
          cols="12"
          sm="6"
          md="1"
          :class="
            $vuetify.breakpoint.name === 'sm' ||
            $vuetify.breakpoint.name === 'xs'
              ? 'd-flex align-start'
              : 'd-flex align-start mt-8'
          "
        >
          <v-btn solo class="white" block height="49" @click="findNameStore">
            <v-icon>mdi-magnify</v-icon>
          </v-btn>
        </v-col>
        <v-col
          cols="12"
          sm="6"
          md="1"
          :class="
            $vuetify.breakpoint.name === 'sm' ||
            $vuetify.breakpoint.name === 'xs'
              ? ''
              : 'mt-8'
          "
        >
          <v-btn solo class="white" block height="49" @click="cleanFields">
            <v-icon>mdi-broom</v-icon>
          </v-btn>
        </v-col>
        <v-col v-if="validaCard" cols="12">
          <v-divider />
          <v-sheet class="text-center mt-4 mb-4">
            Não foi encontrado nenhum cadastro
          </v-sheet>
          <v-divider />
        </v-col>
        <v-col
          v-for="developer in developers"
          v-else
          :key="developer._id"
          cols="12"
          sm="4"
          md="3"
          lg="2"
        >
          <Card
            :developer="developer"
            @edit="editedItem"
            @deleteItem="deleteItem"
          />
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12">
          <v-pagination
            v-model="page"
            :length="pageCount"
            :total-visible="15"
            @input="changePage"
          />
        </v-col>
      </v-row>
    </v-card>
    <modal
      v-if="dialogCreate"
      :id="id"
      :open="dialogCreate"
      @close="closeDialog"
      @freshList="findStore"
    />
    <delete-dialog
      v-if="dialogDelete"
      :id="id"
      :open="dialogDelete"
      @close="closeDialog"
      @freshList="findNameStore"
    />
  </v-container>
</template>
<script>
import './index.css'
import Card from '@/components/card/index.vue'
import Modal from './dialogs/dialog.vue'
import deleteDialog from './dialogs/dialogDelete.vue'
import { mapGetters } from 'vuex'
import moment from 'moment'
export default {
  components: {
    Card,
    modal: Modal,
    'delete-dialog': deleteDialog
  },

  data() {
    return {
      page: 1,
      pageCount: 1,
      itemsPerPage: 12,
      findName: '',
      dialogCreate: false,
      dialogDelete: false,
      id: '',
      developers: [],
      validaCard: false
    }
  },

  computed: {
    ...mapGetters(['getDevelopers', 'getDevelopersPagination'])
  },

  async created() {
    await this.mountedItemsPerPage()
    this.findStore()
  },

  async mounted() {
    await this.mountedItemsPerPage()
    await this.findAllDevelopers()
  },

  methods: {
    findNameStore() {
      this.page = 1
      this.findStore()
    },

    async findStore() {
      const params = {
        itemsPerPage: this.itemsPerPage,
        page: this.page ? this.page : 1,
        findName: this.findName
      }
      await this.$store.dispatch('actionFindAll', params)
      await this.findAllDevelopers()
    },

    async findAllDevelopers() {
      this.pageCount = this.getDevelopers.totalPages
        ? this.getDevelopers.totalPages
        : 1
      this.developers = await this.getDevelopers.data
      if (this.developers.length === 0) {
        this.validaCard = true
      } else {
        this.validaCard = false
      }
      this.convertDate()
    },

    convertDate() {
      for (const key in this.developers) {
        this.developers[key].birthdate = moment(
          this.developers[key].birthdate,
          'YYYY-MM-DD'
        ).format('DD/MM/YYYY')
      }
    },

    createDeveloper() {
      this.id = null
      this.$emit('criar', this.developer)
      this.dialogCreate = true
    },

    async changePage() {
      await this.findStore()
    },

    editedItem(id) {
      this.id = id
      this.dialogCreate = true
    },

    deleteItem(id) {
      this.id = id
      this.dialogDelete = true
    },

    closeDialog() {
      this.dialogCreate = false
      this.dialogDelete = false
    },

    cleanFields() {
      this.findName = ''
      this.findStore()
    },

    mountedItemsPerPage() {
      switch (this.$vuetify.breakpoint.name) {
        case 'xs':
          this.itemsPerPage = 2
          break
        case 'sm':
          this.itemsPerPage = 6
          break
        case 'md':
          this.itemsPerPage = 8
          break
        case 'lg':
          this.itemsPerPage = 12
          break
        case 'xl':
          this.itemsPerPage = 12
          break
        default:
          break
      }
    }
  }
}
</script>
